"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _awsSdk = require("aws-sdk");

var _bluebird = _interopRequireDefault(require("bluebird"));

/* eslint import/no-extraneous-dependencies: ["error", {"devDependencies": true}] */
_awsSdk.config.setPromisesDependency(_bluebird.default);

class Connector {
  constructor({
    debug,
    queueUrl = process.env.QUEUE_URL,
    timeout = Number(process.env.SQS_TIMEOUT) || Number(process.env.TIMEOUT) || 1000
  }) {
    this.debug = debug;
    this.queueUrl = queueUrl || 'undefined';
    this.queue = new _awsSdk.SQS({
      httpOptions: {
        timeout // agent: sslAgent,

      },
      logger: {
        log:
        /* istanbul ignore next */
        msg => this.debug(msg)
      }
    });
  }

  sendMessageBatch(inputParams) {
    const params = {
      QueueUrl: this.queueUrl,
      ...inputParams
    };
    return this.queue.sendMessageBatch(params).promise().tap(this.debug).tapCatch(this.debug);
  }

}

var _default = Connector;
exports.default = _default;