"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UNKNOWN_KINESIS_EVENT_TYPE = exports.toKinesisRecords = exports.fromKinesis = void 0;

var _highland = _interopRequireDefault(require("highland"));

var _utils = require("../utils");

const fromKinesis = event => (0, _highland.default)(event.Records).map(record => ( // create a unit-of-work for each event
// so we can correlate related work for error handling
{
  record,
  event: Buffer.from(record.kinesis.data, 'base64').toString('utf8')
})).map((0, _utils.faulty)(uow => ({ ...uow,
  event: {
    id: uow.record.eventID,
    ...JSON.parse(uow.event)
  }
}))); // test helper


exports.fromKinesis = fromKinesis;

const toKinesisRecords = events => ({
  Records: events.map((e, i) => ({
    eventSource: 'aws:kinesis',
    // eventVersion: '1.0',
    eventID: `shardId-000000000000:${i}`,
    // eventName: 'aws:kinesis:record',
    // invokeIdentityArn: 'arn:aws:iam::123456789012:role/lambda-role',
    awsRegion: 'us-west-2',
    // eventSourceARN: 'arn:aws:kinesis:us-west-2:123456789012:stream/lambda-stream',
    kinesis: {
      // kinesisSchemaVersion: '1.0',
      // partitionKey: e.partitionKey,
      sequenceNumber: `${i}`,
      data: Buffer.from(JSON.stringify(e)).toString('base64') // approximateArrivalTimestamp: 1545084650.987,

    }
  }))
});

exports.toKinesisRecords = toKinesisRecords;
const UNKNOWN_KINESIS_EVENT_TYPE = toKinesisRecords([{
  type: 'unknown-type'
}]);
exports.UNKNOWN_KINESIS_EVENT_TYPE = UNKNOWN_KINESIS_EVENT_TYPE;